--- channel.c.orig	2004-01-14 14:37:57.000000000 -0300
+++ channel.c	2004-01-14 14:43:26.000000000 -0300
@@ -78,9 +78,37 @@
 	if (!chan->whentohangup) return 0;
 	time(&myt); /* get current time */
 	  /* return, if not yet */
-	if (chan->whentohangup > myt) return 0;
-	chan->_softhangup |= AST_SOFTHANGUP_TIMEOUT;
-	return 1;
+	if ((chan->whentohangup == myt+40) && (chan->rings < 50)) { 
+            chan->rings=50;
+            return 0;
+	} else if ((chan->whentohangup == myt+39) && (chan->rings >= 50)) { 
+            chan->rings=100;
+            return 0;
+	} else if ((chan->whentohangup == myt+30) && (chan->rings < 50)) { 
+            chan->rings=50;
+            return 0;
+	} else if ((chan->whentohangup == myt+29) && (chan->rings >= 50)) { 
+            chan->rings=100;
+            return 0;
+	} else if ((chan->whentohangup == myt+20) && (chan->rings < 50)) { 
+            chan->rings=50;
+            return 0;
+	} else if ((chan->whentohangup == myt+19) && (chan->rings >= 50)) { 
+            chan->rings=100;
+            return 0;
+	} else if ((chan->whentohangup == myt+10) && (chan->rings < 50)) { 
+            chan->rings=50;
+            return 0;
+	} else if ((chan->whentohangup == myt+9) && (chan->rings >= 50)) { 
+            chan->rings=100;
+            return 0;
+        } else if (chan->whentohangup > myt) { 
+            return 0; 
+        } else {
+          chan->rings=100;
+          chan->_softhangup |= AST_SOFTHANGUP_TIMEOUT;
+	  return 1;
+       }
 }
 
 static int ast_check_hangup_locked(struct ast_channel *chan)
@@ -89,6 +117,17 @@
 	ast_mutex_lock(&chan->lock);
 	res = ast_check_hangup(chan);
 	ast_mutex_unlock(&chan->lock);
+
+	if (chan->rings == 100 ) {
+   	  ast_playtones_stop(chan);
+          chan->rings=0;
+        }
+
+	if (chan->rings == 50) {
+   	  ast_playtones_start(chan,7110,"440/100,600/100,0/200", 0);
+          chan->rings++;
+        } 
+
 	return res;
 }
 
